> module Yahc.Missing where

> permutations            :: [a] -> [[a]]
> permutations xs0        =  xs0 : perms xs0 []
>  where
>    perms []     _  = []
>    perms (t:ts) is = foldr interleave (perms ts (t:is)) (permutations is)
>      where interleave    xs     r = let (_,zs) = interleave' id xs r in zs
>            interleave' _ []     r = (ts, r)
>            interleave' f (y:ys) r = let (us,zs) = interleave' (f . (y:)) ys r
>                                     in  (y:us, f (t:y:us) : zs)

-- | The 'subsequences' function returns the list of all subsequences of the argument.
--
-- > subsequences "abc" == ["","a","b","ab","c","ac","bc","abc"]

> subsequences            :: [a] -> [[a]]
> subsequences xs         =  [] : nonEmptySubsequences xs

-- | The 'nonEmptySubsequences' function returns the list of all subsequences of the argument,
--   except for the empty list.
--
-- > nonEmptySubsequences "abc" == ["a","b","ab","c","ac","bc","abc"]

> nonEmptySubsequences         :: [a] -> [[a]]
> nonEmptySubsequences []      =  []
> nonEmptySubsequences (x:xs)  =  [x] : foldr f [] (nonEmptySubsequences xs)
>  where f ys r = ys : (x : ys) : r
