> module Yahc.PrettyExpr where
> import Yahc.Pretty
> import Yahc.Expr

-- Pretty-printing expressions.

> instance Pretty Expr where
>     prettyPrec _ (Var v) = text v
>     prettyPrec _ (Con k) = text k
>     prettyPrec n (UnSym s e) = if n > prec s
>                                then parens ((text . show) s <> prettyPrec 0 e)
>                                else (text . show) s <> prettyPrec (prec s) e
>     prettyPrec n (Sym s e e') = if n > prec s
>                                 then parens $ cat [prettyPrec 0 e, spaced s, prettyPrec 0 e']
>                                 else cat [prettyPrec (prec s) e, spaced s, prettyPrec (prec s) e']
>         where spaced :: Symbol -> Doc
>               spaced s = text $ " " ++ show s ++ " " 

